
Core - Bug # 17354

Status: Under Review Priority: Should have
Author: Daniel Poetzinger Category: Frontend
Created: 2007-07-22 Assigned To: Markus Klein
Updated: 2015-07-25 Due date:
TYPO3 Version: 4.2
PHP Version:
Complexity: nightmare
Is Regression: No
Sprint Focus: Remote Sprint
Subject: fallback for menus. "content_fallback;1,0" has no affect for page records (e.g. menu)
Description

Problem:
It is not possible to define another that default language as fallback. 
This is what TYPO3 does actual:
you can define
 config.sys_language_mode=content_fallback;1,0

What this does is to set 
$this->sys_language_content in tslib_fe.

So only the content is rendered in a alternative fallback language.

- menues fall back to default
- page title fall back to default

So this is not perfect, cause it makes no sense if menues and pagedata fall back to default but content is shown in another fallback
language.

Example:
say you have default=english / 1 = spanish / 2=catalan (spanish language)

typical setting if L=2:
config {
  sys_language_uid =  2
  sys_language_mode=content_fallback;1,0
}

if you view a page where no catalan version is available TYPO3 shows menu title and pagetitle of defaultlanguage and only the
content in spanish. 
(What is far from perfect and not the expected behaviour)

Solution:
- It is neccessary that other functions in the core know a fallbackorder.
- especially the function t3lib_page::getPageOverlay needs to know alternative fallback language uids.

I recommend to introduce a new configuration:
 config.sys_language_fallBackOrder=1,0
(which is used as general fallbackorder)
Attached a patch with the following changes:
t3lib_page:
1) new function getLanguageOverlayUidForPage($page_id,$fallBackOrder)
(function that checks which page record overlay language should be used, according to the given fallbackorder)
2) adjust getPageOverlay to use fallback uid instead of default

tslib_fe
1) settingLanguage():
set $this->sys_language_overlayCheckOrder
load fallback overlay for actaul page if needed

tslib_menu
1) adjust filterMenuPages to work with the changes

view attached patches 
(i use head of branch 4.1)
(issue imported from #M6009)

Related issues:
related to Core - Bug # 36616: TYPO3 4.7 sectionIndex not working correctly o... Resolved 2012-04-26
related to Core - Bug # 19114: sys_language_mode does not work Under Review 2008-07-16
related to Core - Bug # 53120: Proper fetching of records in a language in th... New 2013-10-25
related to Core - Bug # 48673: Changed language overlay behaviour in TYPO3 6.* Accepted 2013-05-30
related to Core - Bug # 19718: Typoscript:  CONTENT | slide: multilanguage no... Accepted 2008-12-18
duplicated by Core - Bug # 20623: content_fallback for whole page, including ... Closed 2009-06-16
duplicated by Core - Bug # 60052: sys_language_mode=content_fallback only sup... Closed 2014-07-02

History
#1 - 2007-08-15 22:30 - Sareen Millet

I observed the same problem. Then I tried the suggested patches but for me they don't Work. (I use Typo3 Version 4.12)
Has anybody another solution for the problem?

#2 - 2007-08-23 16:12 - Daniel Poetzinger

they should work.

did you set new setting:

config.sys_language_fallBackOrder=1,0

#3 - 2007-08-23 19:15 - Sareen Millet

Hi Daniel,

I used: config.sys_language_mode = content_fallback; 1,0
Why did you change this config to 
config.sys_language_fallBackOrder=1,0
I expected the patch to do the same thing as typo3 should do. So I used the normal config.
Now it's working.
Thanks.
Hope this bug is solved in the new Typo3 4.2.0 Version.

greetings

Sareen

#4 - 2007-09-29 02:12 - Daniel Poetzinger

Its because the sematic difference
config.sys_language_mode = content_fallback; 1,0

controls the content fallback, and the fallbackorder is not implemented in a way it could easy be used for a common fallback order.

I my opinion having that common config parameter is more clear. (It changes not only content behaviour - which can also be set to something diffrent
than content_fallback - but changes common language fallback)

#5 - 2008-01-14 13:04 - Andreas 

thanx daniel!! works perfect. i also think it's better to define the fallback order in an own config property.

#6 - 2008-01-27 20:27 - Sareen Millet

Hi Daniel,

your patch is perfect, thank you. I played around with it for quite some time now. 
There remains only one problem with realUrl. The text in the Url still has not the correct language fallBackOrder. 
Is there a solution to this?

greetings

Sareen

#7 - 2008-02-25 00:03 - Ronald Steiner

Seams same problem occurs with: 
pi_getFFvalue()  
- used for FlexForm
Language fallback in steps seams to be quite some problem

#8 - 2008-04-17 13:11 - Clemens Riccabona

Is this coming up in 4.2? Does anybody know?

#9 - 2008-07-01 17:57 - Sonja Schubert

still not in 4.2.1, please integrate this!
#10 - 2008-07-01 19:49 - Daniel Poetzinger

I will soon publish the extension langaugevisibility which resolves this and a lot more:
http://www.typo3-media.com/extensions/multilanguages-websites-with-typo3-languagevisibility.html

#11 - 2008-07-02 10:22 - Jonas Felix

confirm: the extension works great, we use it in two projects! This has to be integrated into the core!

#12 - 2008-07-02 10:45 - Ronald Steiner

Is this extension for download  and test already somewhere?

#13 - 2008-07-02 11:06 - Jonas Felix

@ronald: the extension is attached to this bug report: http://bugs.typo3.org/file_download.php?file_id=2929&#38;type=bug

#14 - 2008-07-02 13:09 - Ronald Steiner

as far as I see, this is "just" the bugfix. And there will be an huge extension "languagevisibility" that solves this bug and adds a lot of features.

#15 - 2008-07-17 11:42 - Jonas Felix

but shouldn't such thing be integrated in the core?

I'm realy carefull with such core changing extensions, they can lead to other problems. Is it tested with TV, Workspaces and all the other needed
TYPO3 things?

#16 - 2008-07-17 19:28 - Daniel Poetzinger

sure its tested with workspaces / templavoila / even introduce new templavoila features

the extension is availabe at forge: http://forge.typo3.org/projects/show/extension-languagevisibility

sildes:
http://www.typo3-media.com/extensions/multilanguages-websites-with-typo3-languagevisibility.html

#17 - 2008-08-19 18:00 - Andreas 

thanx!! works like a charm!

#18 - 2008-08-31 09:04 - Ronald Steiner

Hi Daniel,
I just test your extension: languagevisability 
- it seems to work fine so far, but the bug described here is not resolved, is it? Or is there a special TypoScript Configuration necessary to resolve this
bug?

And it seems not possible to install that extension together with the patch you proviede here:
T3X_danp_languagefallback_patch-0_0_0-z-200708151515.t3x

Schould this patch not be integrated in your extension languagevisability? Am I getting something wrong?

greetings

Ron

#19 - 2008-08-31 09:08 - Ronald Steiner

P.S.: For me correct language fallback in menu's is more important, so I now only use the patch and not the extension.

#20 - 2009-04-06 15:09 - Michael Stucki

Daniel, can you update the patch for TYPO3 4.2 please? Additionally, please check my patch in #19114.
It seems to work quite different than the solution that you have come to. What it basically does is the provide content-fallback even if the page record
has been translated, but not all content on it.

Any feedback is appreciated.

- michael

#21 - 2009-07-14 11:12 - Jonas Felix

It would be great if somebody could writhe a manual on how to implement translation handling for records in extensions. But a way which supports the
full features of translation handling in TYPO3.

Is this integrated in the ExtBase persitence layer?

#22 - 2011-03-10 15:34 - Dmitry Dulepov

I attach another patch, which fixes everything.

According to the docs menu and page title should be translated as well when content_fallback is in use. This means that the page record and
$TSFE->sys_language_uid should be set to a fallback language. Indirectly this is confirmed by TSRef in the description of sys_language_uid:

<blockquote>Internally, the value is depending on whether a Alternative Page Language record can be found with that language. If not, the value will
default to zero (default language) except if “sys_language_mode” is set to a value like “content_fallback”.</blockquote>

and

<blockquote>The system will always operate with the selected language even if the page is not translated with a page overlay record. This will keep
menus etc. translated</blockquote>
So the patch checks if the fallback is set and changes page record and sys_language_uid to be the one from fallback, which makes the behavior
identical to described in TSRef.

Result: menu in the fallback language, page title in the fallback language, links still stay with user's choosen language.

One possible drawback could be with language selectors. If they use $TSFE->sys_language_uid, they will show a fallback language. Instead they
should use the value of "L".

#23 - 2011-03-29 15:56 - Juergen Weber
- Target version deleted (0)

I have this issue in TYPO3 version 4.5. Isn't this fixed yet? Dimitry, will your patch also work with 4.5?

#24 - 2011-04-04 12:04 - amareco 

The problem is´nt fixed in Typo3 4.5.2 but the patch works there.

#25 - 2011-06-06 14:07 - Philipp Idler

amareco  wrote:

The problem is´nt fixed in Typo3 4.5.2 but the patch works there.

what patch? dmitry's?
doesn't work for me (4.5.3)

i don't understand why this isn't part of the core...

#26 - 2011-06-16 14:51 - Evgeniy Martynov

Hi,

Dmitry Dulepov wrote:

I attach another patch, which fixes everything.
...

I checked both solutions.

While danp_languagefallback_patch adrresses the issue the patch from Dmitrij does not at all.

The main problem is not translation of the currently selected page record (while in content_fallback mode), but rather falling back while translating
menu items for other pages which are present in the menu.

Dmitrij's patch works only with currently selected page, while danp_languagefallback_patch reimplements getPageOverlay which actually provides
menu biulding class with translated page records.
#27 - 2012-01-13 10:11 - Dmitry Dulepov
- Category deleted (Communication)

Dan's patch is incorrect because it adds a dependency from t3lib_page to TSFE. This should not happen. There must be a different solution.

#28 - 2012-03-22 14:23 - Henrik Ziegenhain

Any news on this issue?
It`s still reproducable in 4.6.6

#29 - 2012-03-22 15:10 - Stefan Galinski
- File l10nFallback.patch added

I have written a small patch for the site [[http://www.ashtangayoga.info/]] last week that consideres the configured content_fallback setting for pages
too. Furthermore it introduces a new API method to overlay other non-page records with a possible fallback, but you must modify the necessary
extensions yourself. It's already done for the core and so that stuff should already work in most cases. Just have a look at the patch for more details.
Feedback is welcome and maybe this simple patch or a modification of it can be submitted to Gerrit sooner or later.

#30 - 2012-03-22 15:25 - Henrik Ziegenhain

Hi Stefan,

meanwhile I tested Dmitrys patch - It solves the main problem with non translated navigations, but there are strange side effects I can`t discribe.
I will give your patch shortly a try - would be great to see this in core.

#31 - 2012-03-23 12:16 - Henrik Ziegenhain

Hi Stefan,

I set up an test installation and imported my site (12 Languages!).
Everything is working as expected after applying your patch.

From my humble point of view you maybe could submit it to Gerrit.

PS: I think this is also related to #20623

#32 - 2012-03-23 13:00 - Stefan Galinski
- Status changed from New to Accepted
- Assigned To set to Stefan Galinski

Hi Henrik,

I marked #20623 as a duplicate of this one and will submit the patch to Gerrit for 4.8 only (and 4.5/4.6 backports afterwards if Ernesto/Xavier want it) in
some days to get some more feedback and practical results as the patch is already running in a live installation. Thanks for your review! :-)
#33 - 2012-03-27 23:19 - Stefan Galinski

Hi Henrik,

I fixed a possible edge-case in the patch and will upload this to one to Gerrit now. Please review it again carefully, just to be sure that nothing else
slipped in and don't forget voting in Gerrit. Thanks in advance! :-)

Edit: Everyone and not just Hendrik is invited to do the same. ;-)

#34 - 2012-03-27 23:20 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9937

#35 - 2012-03-28 11:18 - Henrik Ziegenhain

Thanks Stefan,

+1 by reading - Is there a way to download the changes as patch-file to apply it to my local installation?
I did not really deal with the new review system before. Sorry.

After a short test I will give my vote in Gerrit.

#36 - 2012-03-28 13:30 - Stefan Galinski
- File l10nFallback.patch added

I attached the new version of the patch directly taken from Gerrit by using the patch command. To get such a patch by yourself, you just need to clone
the git repository of TYPO3 and execute one of the mentioned commands below a patchset in Gerrit on the sources.

#37 - 2012-04-13 12:41 - Stefan Galinski
- % Done changed from 0 to 90
- Estimated time set to 50.00
- Complexity set to nightmare

#38 - 2012-04-13 12:45 - Daniel Poetzinger

Why not using languagevisibility? :-) Its all working there and a lot of more things..

Just my 2 cents :-)

#39 - 2012-04-13 13:01 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9937
#40 - 2012-04-13 14:27 - Stefan Galinski

Hi Daniel,

Your extension does lot's of more stuff and that's exactly the problem. Also I didn't understood the code and it didn't worked for me like I had expected
it (just install it, define the fallback order and go).

#41 - 2012-04-13 17:21 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9937

#42 - 2012-05-04 08:26 - Henrik Ziegenhain

Push :)

Stefan and Ronald, could you please also look at the new patch from Markus?

#43 - 2012-06-26 23:37 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9937

#44 - 2012-07-27 16:01 - Stefan Regniet

Hi together. Just tested the patch on a page with > 40 languages (on a patched 4.7.2). Works fine so far.
But it seems that it ignores l18n_cfg setting (2) in page-record (Hide page if no translation is available). 
So I don't have any chance to explicitly hide certain pages that I don't want to show in fallback.

That one should be patched in t3lib_page imho... Thanks :)

#45 - 2012-08-13 19:20 - Stefan Galinski

Really? This setting works for me!? Please test the latest version of the patch. Will be there in a few minutes... :-)

#46 - 2012-08-13 19:23 - Gerrit Code Review

Patch set 5 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9937

#47 - 2012-08-14 14:51 - Gerrit Code Review

Patch set 6 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9937
#48 - 2012-08-14 14:55 - Gerrit Code Review

Patch set 7 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9937

#49 - 2012-08-16 21:35 - Gerrit Code Review

Patch set 8 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9937

#50 - 2012-08-16 21:38 - Gerrit Code Review

Patch set 9 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9937

#51 - 2012-08-19 22:35 - Gerrit Code Review

Patch set 10 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9937

#52 - 2012-09-09 02:34 - Gerrit Code Review

Patch set 11 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9937

#53 - 2012-09-09 02:42 - Gerrit Code Review

Patch set 12 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9937

#54 - 2012-09-25 13:17 - Gerrit Code Review

Patch set 13 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9937

#55 - 2012-09-25 13:20 - Gerrit Code Review

Patch set 14 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/9937

#56 - 2013-01-08 10:23 - Camelia M

It seems to me this is a bug in typo3 6.0 also
#57 - 2013-01-09 14:55 - Gerrit Code Review

Patch set 15 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/9937

#58 - 2013-01-09 14:59 - Gerrit Code Review

Patch set 16 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/9937

#59 - 2013-01-16 13:20 - Camelia M

Patch 16 seems to work fine for me. Thank you

#60 - 2013-03-15 15:09 - Camelia M

Camelia M wrote:

Patch 16 seems to work fine for me. Thank you

Actually, after I apply this patch, localizations for jfmulticontent stop working. Not sure if this is the only one that stops working, but this is the first I
noticed.

#61 - 2013-03-22 16:31 - Camelia M

Camelia M wrote:

Camelia M wrote:

Patch 16 seems to work fine for me. Thank you

Actually, after I apply this patch, localizations for jfmulticontent stop working. Not sure if this is the only one that stops working, but this is the first I
noticed.

I forgot to mention that I did replace getRecordOverlay function call with getRecordOverlayWithFallback

#62 - 2013-06-14 01:43 - Gerrit Code Review

Patch set 17 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/9937

#63 - 2013-06-14 02:04 - Gerrit Code Review

Patch set 18 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/9937
#64 - 2013-06-15 01:39 - Gerrit Code Review

Patch set 19 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/9937

#65 - 2013-07-07 01:10 - Gerrit Code Review

Patch set 20 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/9937

#66 - 2013-08-11 19:56 - Gerrit Code Review

Patch set 21 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/9937

#67 - 2013-09-23 13:53 - Stefan Galinski
- Assigned To deleted (Stefan Galinski)
- Is Regression set to No

#68 - 2013-10-01 09:45 - Marius S.

Has anyone a patch for TYPO3 6.0.4? Patch set 21 isn't working in this version.

#69 - 2014-07-15 17:41 - Marc Steiner

Stefan Regniet wrote:

Hi together. Just tested the patch on a page with > 40 languages (on a patched 4.7.2). Works fine so far.
But it seems that it ignores l18n_cfg setting (2) in page-record (Hide page if no translation is available). 
So I don't have any chance to explicitly hide certain pages that I don't want to show in fallback.

That one should be patched in t3lib_page imho... Thanks :)

Hi all,
we applied the patch set 21 to our 6.2 installation, but we also had the problem, that it ignores the l18n_cfg setting as mentioned above.

To fix this(at least for the basic HMENU) we changed line number 975 in the file 
typo3/sysext/frontend/Classes/ContentObject/Menu/AbstractMenuContentObject.php.

In function filterMenuPages after:
if ($GLOBALS['TSFE']->sys_language_uid && GeneralUtility::hideIfNotTranslated($data['l18n_cfg'])) {

-       if (!$data['_PAGES_OVERLAY']) {
+       if (!$data['_PAGES_OVERLAY'] || ($data['_PAGES_OVERLAY_LANGUAGE'] != $data['sys_language_uid'])) {
#70 - 2014-09-23 08:48 - Wolfgang Hamster

why this bug isn't resolved in typo3 6.2 yet?
is there any extension to fix it?

#71 - 2014-09-23 09:06 - Stefan Neufeind

There is a patch under review. Maybe that works for you? But it was mentioned in the review that somebody still had an issue with it. And currently it
seems to be handled as a "feature" (won't have this for 6.2 then unfortunately) and not as a bugfix.

#72 - 2014-10-02 15:24 - Gerrit Code Review

Patch set 22 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/9937

#73 - 2014-10-02 18:25 - Gerrit Code Review

Patch set 23 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/9937

#74 - 2014-10-07 16:59 - Marc Hirdes

So ist there any current workaround for TYPO3 6.2?

#75 - 2014-10-07 17:41 - Stefan Galinski

Not really, but you can apply the patch yourself in 6.2 if you know how to do that. AFAIK there are not many differences, so you shouldn't get any
errors.

#76 - 2014-10-08 08:38 - Marc Hirdes

But then I can't update the core when a new minor-version is published. Aren't there any other solutions? Isn't there any bugfix for 6.2?

#77 - 2014-10-08 10:48 - Mathias Brodala

Marc Hirdes wrote:

But then I can't update the core when a new minor-version is published.

You can always re-apply the patch on update. In case you are using Composer the composer-patches-plugin might prove useful here.

Aren't there any other solutions? Isn't there any bugfix for 6.2?
Since the change has not been merged yet, there cannot be a bugfix release including it.

#78 - 2014-10-08 11:51 - Marc Hirdes

I don't use composer. For my local distribution it is only possible to set all changes manually in files?

Is it possible, that the next bugfix release include it?

#79 - 2014-10-08 11:58 - Mathias Brodala

Marc Hirdes wrote:

I don't use composer. For my local distribution it is only possible to set all changes manually in files?

Not necessarily if you use the patch command. :-)

#80 - 2014-10-08 14:47 - Marc Hirdes

OK I used the patch command. First it looks ok. But RealURL returns also a bad URL and another Extension provides also the wrong title. In this 
https://forge.typo3.org/issues/18062 Issu is said, that RealURL expects the correct Lang-Param from core.

Am I the only one with this problem? I meen in many multilanguage pages I think they would have different fallbacks for different languages (austria ->
german, us -> uk etc.).

Are there experiences with other extensions? And will this patch include in the Core maybe? Thanks a lot for support.

#81 - 2014-10-16 18:59 - Stefan Galinski

I found a fix, but realurl can't handle the resulting urls with fallback names inside them. The root cause is that sometimes getPageOverlay is called with
an explicit language parameter and this means to the function that the user want's exactly this language. Changing this behaviour will automatically be
a breaking change.

#82 - 2014-10-16 23:56 - Gerrit Code Review

Patch set 24 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/9937

#83 - 2014-10-21 10:03 - Marc Hirdes

To handle RealUrl I translated every page. So the title of the page is correct and also the URL. My last problem is with Gridelemnts. When I have an
element inside of antother element the fallback is the default language. Other elements are shown correct in the fallback language.

#84 - 2014-10-21 14:12 - Marc Hirdes

OK, when I change in Gridelements.php line 161 getRecordOverlay to getRecordOverlayWithFallback it works fine.
$child = $GLOBALS['TSFE']->sys_page->getRecordOverlayWithFallback('tt_content', $child, $GLOBALS['TSFE']->sys_language_content,
$GLOBALS['TSFE']->sys_language_contentOL);

Maybe the funtion getRecordOverlay can allways get the fallback, if no translation is given?

#85 - 2014-11-05 17:22 - Gerrit Code Review

Patch set 25 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/9937

#86 - 2014-11-05 20:45 - Gerrit Code Review

Patch set 26 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/9937

#87 - 2014-11-05 20:53 - Gerrit Code Review

Patch set 27 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/9937

#88 - 2015-01-03 11:47 - Gerrit Code Review

Patch set 28 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/9937

#89 - 2015-07-04 03:01 - Gerrit Code Review

Patch set 29 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/9937

#90 - 2015-07-04 03:06 - Gerrit Code Review

Patch set 30 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/9937

#91 - 2015-07-04 03:07 - Gerrit Code Review

Patch set 31 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/9937

#92 - 2015-07-25 12:49 - Markus Klein
- Category set to Frontend
- Assigned To set to Markus Klein
- PHP Version deleted (4.3)
- Sprint Focus set to Remote Sprint
Files
patch_class.t3lib_page.txt 3 kB 2007-07-22 Administrator Admin
patch_class.tslib_fe.txt 3.1 kB 2007-07-22 Administrator Admin
patch_class.tslib_menu.txt 889 Bytes 2007-07-22 Administrator Admin
T3X_danp_languagefallback_patch-0_0_0-z-200708151515.t3x 7.9 kB 2007-08-23 Administrator Admin
6009_dmitry.diff 1.4 kB 2011-03-10 Administrator Admin
l10nFallback.patch 9.7 kB 2012-03-22 Stefan Galinski
l10nFallback.patch 8.7 kB 2012-03-28 Stefan Galinski
